/**
 * @Name WonderfulChat Client
 * @Author Adam Boutcher
 * @Date 31-03-2011
 * @Version 0.9 RC
 */

//Lets do some importing!
import java.io.*;
import java.net.*;
import javax.swing.*;
import java.awt.*;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.ClipboardOwner;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.Transferable;
import java.awt.event.*;
import java.awt.Toolkit;
import java.sql.Timestamp;
import javax.net.ssl.SSLSocket;
import javax.net.ssl.SSLSocketFactory;

public class ChatClient extends JFrame implements Runnable
{
	// Some Variables
		//Versioning
		private static final double Version = 0.9;			// Version Number
		private static final String VType = "   RC";		// Version Type; "Alpha", " Beta", "   RC", "Final"
		//Socket stuff
		private static String host = "localhost";			// Chat Server Host, default hostname/ip
		private static final int port = 555;				// SSL Port
		private static SSLSocket socket;
		//Name
		private static String name = "GuestUser";			// Default Username, should only see this if it goes ape.
		//World Window (for popups)
		public static JFrame Popupframe = null;
	// Standard Msg/Error Output
		public static void Msg(String $type, String $message)
		{
			java.util.Date date= new java.util.Date();
			System.out.println("["+new Timestamp(date.getTime())+"] "+$type+": "+$message);
		}
	// Some Sexy Header
		public static void Header()
		{
			//Dirty Hack to clear the screen ready for the log output.
			System.out.print("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
			System.out.println("##############################################");
			System.out.println("#                                            #");
			System.out.println("#                                            #");
			System.out.println("#             WonderfulChat Client           #");
			System.out.println("#               Java-Based Chat              #");
			System.out.println("#                                            #");
			System.out.println("#                                            #");
			System.out.println("# v"+Version+"                                 "+VType+" #");
			System.out.println("##############################################");
			System.out.println("                     Created by: Adam Boutcher\n");
			Msg("Msg", "Starting...");
		}
	// Username stuff
		//Windowing Bits
		private static JTextField Name = new JTextField();
		private static JTextField HostSelect = new JTextField();
		private static final JLabel Question1 = new JLabel("Server Address:");
		private static final JLabel Question2 = new JLabel("Username:");
		private static JButton connectbutton = new JButton("Connect");
		private static JLabel welcome = new JLabel("Welcome to WonderfulChat",SwingConstants.LEFT);
		private static JFrame NameFrame = new JFrame();
		public static void GetName()
		{
			Msg("Msg", "Windowing System Loading...\n");
			//Sexy New Windowing System
			JPanel NameAsk = new JPanel();
			JPanel NameButton = new JPanel();
			JPanel NameBanner = new JPanel();
			NameBanner.setLayout(new BorderLayout());
			NameBanner.add(welcome);
			NameAsk.setLayout(new GridLayout(2,2));
			NameAsk.add(Question1);
			HostSelect.setText(host);
			NameAsk.add(HostSelect);
			NameAsk.add(Question2);
			NameAsk.add(Name);
			NameButton.setLayout(new BorderLayout());
			NameButton.add(connectbutton);
			NameFrame.setLayout(new BorderLayout());
			NameFrame.add("North",NameBanner);
			NameFrame.add("Center",NameAsk);
			NameFrame.add("South",NameButton);
			NameFrame.setSize(350,120);
			NameFrame.setTitle("WonderfulChat Client - "+Version+VType);
			NameFrame.setVisible(true);
			Name.requestFocusInWindow();
			NameFrame.setLocationRelativeTo(null);
		}
	// This is where is connects and starts the main chat window
		public static void connect()
		{
			name = Name.getText();
			host = HostSelect.getText();
			if((name.equals(""))||(host.equals("")))
			{
				//Some checks to see if the input details are entered
				if((name.equals(""))&&(!host.equals("")))
				{
					JOptionPane.showMessageDialog(Popupframe, "Error:\nPlease input a Username.","WonderfulChat Error",JOptionPane.WARNING_MESSAGE);
				}
				else if((!name.equals(""))&&(host.equals("")))
				{
					JOptionPane.showMessageDialog(Popupframe, "Error:\nPlease input a Server address.","WonderfulChat Error",JOptionPane.WARNING_MESSAGE);
				}
				else
				{
					JOptionPane.showMessageDialog(Popupframe, "Error:\nPlease input a Username and Server address.","WonderfulChat Error",JOptionPane.WARNING_MESSAGE);
				}
			}
			else
			{
				SSLSocketFactory sockfactory = (SSLSocketFactory) SSLSocketFactory.getDefault();
				try
				{
					socket = (SSLSocket) sockfactory.createSocket(host, port);
				}
				catch (UnknownHostException e)
				{
					//If the host cannot be resolved
					JOptionPane.showMessageDialog(Popupframe, "Error:\nExiting; Cannot resolve server address.","WonderfulChat Error",JOptionPane.WARNING_MESSAGE);
					Msg("Error","1000 - Unknown Host "+host+".");
					System.exit(1);
				}
				catch (IOException e)
				{
					//If we can't connect for some reason
					JOptionPane.showMessageDialog(Popupframe, "Error:\nExiting; Cannot connect to server.","WonderfulChat Error",JOptionPane.WARNING_MESSAGE);
					Msg("Error","2000 - Cannot connect to "+host+":"+port+".");
					System.exit(1);
				}			
				//Output into the console we're connected.
				Msg("Msg","Successfully joined server.");
				new ChatClient(socket, name);
				//Destroy the first userinput window
				NameFrame.dispose();
			}
		}
	// The main fun
		public static void main(String[] args)
		{
			//Display Our header from earlier
			Header();
			//Get the Username
			GetName();
			//Listen for the button pres/enter and start the chatting fun in a funky window!
			connectbutton.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){connect();}});
			Name.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){connect();}});
			//Exit if close is pressed
			NameFrame.addWindowListener(new WindowAdapter(){public void windowClosing(WindowEvent we){System.exit(1);}});	
		}
		//Variables containing Window/display items
		private JTextField tf = new JTextField();
		private JTextArea ta = new JTextArea();
		private JLabel servername = new JLabel("Server: "+host+":"+port+" ",SwingConstants.RIGHT);
		private JLabel username = new JLabel(" User: "+name);
		private JButton sendbutton = new JButton("Send");
		private static JFrame Frame = new JFrame();
		//Our DataStreams with the conversations included.
		private DataOutputStream dataout;
		private DataInputStream datain;
	// Constructor
		public ChatClient(Socket socket, String name)
		{	        
			//MenuBar
			JMenuBar menuBar = new JMenuBar();
			JMenu filemenu, aboutmenu;
			//Menus
			filemenu = new JMenu("File");
			filemenu.setMnemonic(KeyEvent.VK_F);
			aboutmenu = new JMenu("Help");
			aboutmenu.setMnemonic(KeyEvent.VK_H);
			//Menu Items
			JMenuItem ClipItem = new JMenuItem("Copy to Clipboard");
			JMenuItem ClearItem = new JMenuItem("Clear Chat");
			JMenuItem ExitItem = new JMenuItem("Exit");
			JMenuItem HelpItem = new JMenuItem("Help");
			JMenuItem WebItem = new JMenuItem("Website");
			JMenuItem SourceItem = new JMenuItem("SourceCode");
			JMenuItem AboutItem = new JMenuItem("About");
			ExitItem.setMnemonic(KeyEvent.VK_X);
			filemenu.add(ClipItem);
			filemenu.add(ClearItem);
			filemenu.add(ExitItem);
			aboutmenu.add(HelpItem);
			aboutmenu.add(WebItem);
			aboutmenu.add(SourceItem);
			aboutmenu.add(AboutItem);
			menuBar.add(filemenu);
			menuBar.add(aboutmenu);
	        //TopArea
	        JPanel top = new JPanel();
			top.setLayout(new GridLayout(2,1));
	        JPanel UpperTop = new JPanel();
	        JPanel LowerTop = new JPanel();
			LowerTop.setLayout(new GridLayout(1,2));
			UpperTop.setLayout(new BorderLayout());
			top.add(UpperTop);
			UpperTop.add(menuBar);
			top.add(LowerTop);
			LowerTop.add(username);
			LowerTop.add(servername);
			//Middle area
	        JPanel middle = new JPanel();
			ta.setEditable(false);
			ta.setFocusable(false);
	        JScrollPane scrollingArea = new JScrollPane(ta);
			middle.setLayout(new BorderLayout());
			middle.add(scrollingArea, BorderLayout.CENTER);
			//Bottom Area
	        JPanel bottom = new JPanel();
	        bottom.setLayout(new BoxLayout(bottom,BoxLayout.X_AXIS));
	        bottom.add(tf,BorderLayout.LINE_START);
	        bottom.add(sendbutton,BorderLayout.LINE_END);
	        sendbutton.setToolTipText("Click to Send Message. (Hit Enter)");
			//Whole Area
	        Frame.setSize(350,400);
			Frame.setTitle("WonderfulChat Client - "+Version+VType);
			Frame.setLayout(new BorderLayout());
			Frame.add("North",top);
			Frame.add("Center",middle);
			Frame.add("South",bottom);
			Frame.setLocationRelativeTo(null);
			Frame.setVisible(true);
			tf.requestFocusInWindow();
		// Actions
			//Closing Actions
			Frame.addWindowListener(new WindowAdapter(){public void windowClosing(WindowEvent we){quit();}});
			ExitItem.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){quit();}});
			//Sending the message
			tf.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){processMessage(e.getActionCommand());}});
			sendbutton.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){processMessage(tf.getText());}});
			//Clear the chat
			ClearItem.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){ta.setText("");}});
			//Dialogue Boxes
			WebItem.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e)
			{
				Msg("Msg","Call to open Brower (Website).");
				WebBrowse("http://www.aboutcher.co.uk/");
			}});
			SourceItem.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e)
			{
				Msg("Msg","Call to open Brower (SourceCode).");
				WebBrowse("http://source.uni.aboutcher.co.uk/");
			}});
			//Dialogue Boxes
			AboutItem.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e)
			{
				String COPYRIGHT = "\u00a9";
				JOptionPane.showMessageDialog(Popupframe, "WonderfulChat\n\n Version: "+Version+VType+"\n"+COPYRIGHT+"2011 Adam Boutcher\n\nCreated by: Adam Boutcher\nEmail: adam@aboutcher.co.uk\nWebsite: www.aboutcher.co.uk","About WonderfulChat",JOptionPane.PLAIN_MESSAGE);
			}});
			HelpItem.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e)
			{
				JOptionPane.showMessageDialog(Popupframe, "WonderfulChat Help\n\nThere is no help.","Help",JOptionPane.PLAIN_MESSAGE);
			}});
			//Copy chat to clipboard
			ClipItem.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e)
			{	
				Clipboard systemClipboard =	Toolkit.getDefaultToolkit().getSystemClipboard();
				Transferable transferableText =	new StringSelection(ta.getText());
			    systemClipboard.setContents(transferableText,null);
				Msg("Msg","System Clipboard modified.");

			}});
		// Get the server data streams (the messages).
			try {
				//Streams to and from the server
				datain = new DataInputStream(socket.getInputStream());
				dataout = new DataOutputStream(socket.getOutputStream());
				dataout.writeUTF("System:\n"+name+" Joined.");
				// Start a background thread for receiving messages
				new Thread(this).start();
			}
			catch(IOException ie)
			{
				//Connected but the server refused the connection (No/Invalid SSL)
				JOptionPane.showMessageDialog(Popupframe, "Error:\nExiting; Server refused connection.","WonderfulChat Error",JOptionPane.WARNING_MESSAGE);
				// Print out the error
				Msg("Error","0006 - Server refused connection (SSL Certifcates invalid).");
				System.exit(1);
			}
		}
	// Open the Systems WebBrowser
		public void WebBrowse(String url)
		{
			Boolean TestDesk = Desktop.isDesktopSupported();
			if(TestDesk)
			{
				try
				{
					Desktop.getDesktop().browse(URI.create(url));
				}
				catch (IOException e1)
				{
					JOptionPane.showMessageDialog(Popupframe, "Error:\nCannot Open Browser.","WonderfulChat Error",JOptionPane.WARNING_MESSAGE);
					Msg("Error","0100 - Cannot Open Browser");;
				}
			}
			else
			{
				JOptionPane.showMessageDialog(Popupframe, "Error:\nCannot Open Browser.","WonderfulChat Error",JOptionPane.WARNING_MESSAGE);
				Msg("Error","0100 - Cannot Open Browser (Not supported).");
			}
		}
	// Happy quit Function
		public void quit()
		{
			try {
				dataout.writeUTF("System:\n"+name+" Leaves.");
				//Hacky bit to keep log messages in order.
				Thread.sleep(10);
			}
			catch (IOException e)
			{
				// DO Nothing we're quitting anyway.
			}
			catch (InterruptedException e)
			{
				// DO Nothing we're quitting anyway.
			}
			Msg("Msg","Closing.");
			System.exit(1);
		}
	// This bit sends out message to the server
		private void processMessage(String message)
		{
			try
			{
				if(message.equals(""))
				{
					// Do nothing if the chat is blank.
				}
				else
				{
					// Send it to the server
					Msg("Srv","Message sent.");
					dataout.writeUTF(name+" says:\n"+message );
					// Clear out text input field
					tf.setText("");
				}
			}
			catch(IOException ie)
			{
				Msg("Error","0000 - Unknown Error 2.");
				System.exit(1);
			}
		}
  // Background thread runs this: show messages from other window
		public void run()
		{
			try
			{
				// This just loops constantly
				while (true)
				{
					// Get the next message
					String message = datain.readUTF();
					// Print it to our text window
					ta.append(message+"\n");
					//Scroll it down
					ta.setCaretPosition(ta.getDocument().getLength());
					//Log the message in the console
					Msg("Srv","Message recieved.");
				}
			}
			catch(IOException ie)
			{
				JOptionPane.showMessageDialog(Popupframe, "Error:\nDisconnected from Server;\nPlease restart Client.","WonderfulChat Error",JOptionPane.WARNING_MESSAGE);
				Frame.dispose();
				Msg("Error","0200 - Disconnected From Server.");
				ta.append("** Disconnected from Server **\n");
				ta.append("** Please Restart Client **");
			}
		}
}